;*************************************************************
; Vers 1.1    
;            
;************************************************************
;   Filename:           kotel1_1.asm
;   Date:               nojab  2005
;   Assembler:          mpasm 3.20
;   Author:             Bogdanov Andrew
;   E-Mail:             bogdanov@tsrv.ru
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
; __CONFIG b'00000011000010'        ;   CP on      *
;************************************************************
#include  C:/PHYTON/MY_INC/pic73.mac ;                                     *
;******************** Ports Bits ****************************
#define  Led_A     PORTB,5     ;  
#define  Led_B     PORTB,7     ;  
#define  Led_C     PORTB,1     ;  
#define  Led_D     PORTB,3     ;  
#define  Led_E     PORTB,4     ;  
#define  Led_F     PORTB,6     ;  
#define  Led_G     PORTB,0     ;  
#define  Led_T     PORTB,2     ;  
;************************************************************
#define  Led_Low   PORTA,3     ;  
#define  Led_Midl  PORTA,2     ;  
#define  Led_High  PORTA,5     ;  
;************************************************************
NogDS1821    equ   5  ;   ( 1)
#define  DS1821_1    PORTC,5   ;  DS1821
;************************************************************
#define  Kotel       PORTC,3   ;    
#define  ButtonUP    PORTA,0   ;  
#define  ButtonDOWN  PORTA,1   ;  
;************************************************************
;           Register Definitions  20h - 7fh
;******  Roller *************************************
mCountTimer    equ   0x21  ; nbmer
mCountIND      equ   0x22  ;  
mPosHigh       equ   0x23  ;  
mPosMidl       equ   0x24  ;   
mPosLow        equ   0x25  ;  
mCountBcuc     equ   0x26  ;
mCountBlink    equ   0x27  ;
mCountDown     equ   0x28  ;
mCountKeyOut   equ   0x29  ;    
;*************************************************************
uTempUp        equ   0x30  ;  
uTempDown      equ   0x31  ;  
uTempDelta     equ   0x32  ;   ust-on/ust+off
uTempUst       equ   0x33  ;   
uTempReal      equ   0x34  ;   
;----------------------------------------------------------
mDelay         equ   0x3A   ;    
mToDS1821      equ   0x3B   ;     1
mFromDS1821    equ   0x3C   ;     1
;*************************************************************
wDdsHex        equ   0x40  ;  HEX->DDS
wDdsLow        equ   0x41  ; i
wDdsMid        equ   0x42  ;
wDdsHigh       equ   0x43  ;
;----------------------------------------------------------
wTEMP          equ   0x44  ; DS1821
wlocal1        equ   0x45  ; DS1821
wlocal2        equ   0x46  ; DS1821
;*************************************************************
        ORG     0        ;  
;***********************************************************************
        goto    Start    ;    
;*************************************************************
hex:     ;  .    ASCII
;*************************************************************
        andlw   0x0F        ;  16 
        addwf   PC,f        ;
        goto    Simbol_0    ;   
        goto    Simbol_1    ;  
        goto    Simbol_2    ;
        goto    Simbol_3    ;
        goto    Simbol_4    ;
        goto    Simbol_5    ;
        goto    Simbol_6    ;
        goto    Simbol_7    ;
        goto    Simbol_8    ;
        goto    Simbol_9    ;
        goto    Simbol_T1   ; 10
        goto    Simbol_T2   ; 11
        goto    Simbol_c    ; 12  
        goto    Simbol_dw   ; 13  
        goto    Simbol_ust  ; 14  
        goto    Simbol_F    ; 15
;***********************************************************************
        ORG    100H                 ;  
;***********************************************************************
Start:                              ; Main Programm
            bsf         STATUS,RP0  ; c 1
            movlw       b'00010011' ; A0-4 =in
            movwf       TRISA       ; A5  = out
            movlw       b'00000000' ; B0-B7 - inputs
            movwf       TRISB       ; DMX address
            movlw       b'10000111' ; C0-C6-out stepmotor
            movwf       TRISC       ; C7=RX,C6=TX
            movlw       b'00000000' ; 1:256S->Presc->Tmr0,
            movwf       OPTIONR     ;
            movlw       b'00000111' ; 
            movwf       ADCON1      ;
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'025'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00000010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         STATUS,RP0  ; c 0
;*************************************************************
            movlw       b'10011101' ;  
            movwf       ADCON0      ; ADC
            movlw       b'00010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            clrf        INTCON      ; NO 
;-------------------------------------------------------------
        clrwdt             ;  WDT 
        clrf    PORTB           ; .
        clrf    PORTA           ; .
        mvi     mCountDown,.10  ;
        mvi     uTempUst,.80    ;   
        call    USTdelta        ; .   ust-on/ust+off
        CALL    initDS1821      ;   1
;*************************************************************
ZastCuc:   ;   9  0
;*************************************************************
        mvi     mPosHigh,.11      ; 
        mov     mPosMidl,wDdsLow  ; 
        mvi     mPosLow,.10       ; 
        mov     wDdsHex,mCountDown;  HEX->DDS
        call    HexToDec          ; dds_hex -> . - 3 
        call    TimerWait
        cpi     mCountDown,0xff
        jnz     ZastCuc
;*************************************************************
BaseCuc:   ;  
;*************************************************************
        mov     wDdsHex,uTempReal ;   
        call    HexToDec          ; dds_hex -> . - 3 
        mvi     mPosLow,.12       ;  
        mov     mPosMidl,wDdsLow  ;  
        mov     mPosHigh,wDdsMid  ;  
        call    TimerWait
        call    CheckTemp         ;  
;-------------------------------------------------------------
        btfss   ButtonUP
        goto    UstTempcuc
        btfss   ButtonDOWN
        goto    UstTempcuc
        mvi     mCountBlink,.240; 
        clrf    mCountKeyOut    ;    
        goto    BaseCuc
;*************************************************************
UstTempcuc:   ;   
;*************************************************************
        mvi     mPosHigh,.14      ;  
        mov     wDdsHex,uTempUst  ;  
        call    HexToDec          ; dds_hex -> . - 3 
        mov     mPosMidl,wDdsMid  ;  
        mov     mPosLow,wDdsLow   ;  
        call    TimerWait
        btfss   ButtonUP
        goto    UstTempUp
        btfss   ButtonDOWN
        goto    UstTempDOWN
UstTempReset:
        mvi     mCountBlink,.1    ; 
        cpi     mCountKeyOut,.25  ;    
        jz      BaseCuc
        goto    UstTempcuc        ;   
;-------------------------------------------------------------
UstTempUp:
        clrf    mCountKeyOut    ;    
        cpi     mCountBlink,.2  ;   
        jnz     UstTempcuc
        clrf    mCountBlink
        cpi     uTempUst,.94    ;  = 95!!!
        jnc     UstTempcuc      ;   
        incf    uTempUst,f      ;  
        goto    UstTempcuc      ;   
;-------------------------------------------------------------
UstTempDOWN:
        clrf    mCountKeyOut    ;    
        cpi     mCountBlink,.2    ;   
        jnz     UstTempcuc
        clrf    mCountBlink
        cpi     uTempUst,.15    ; in  35
        jc      UstTempcuc      ;   
        decf    uTempUst,f      ;  
        goto    UstTempcuc          ;   
;*************************************************************
CountCuc:   ;   0  255
;*************************************************************
        call    TimerWait
        mov     wDdsHex,mCountBlink ;  HEX->DDS
        call    HexToDec          ; dds_hex -> . - 3 
        mov     mPosHigh,wDdsHigh ;  
        mov     mPosMidl,wDdsMid  ;  
        mov     mPosLow,wDdsLow   ;  
        goto    CountCuc          ;   
;*************************************************************
;/////////////////////////////////////////////////////////////
;**************************************************************
TimerWait:
;**************************************************************
        clrwdt              ;  WDT 
        btfss   TMR0,5      ; !
        goto    TimerWait   ;  =0 -> 
        clrf    TMR0        ;  =1 ->  
        incf    mCountTimer,f
        jnz     TimerWait   ;     
;--------------------------------------------------------------
;       - 
;--------------------------------------------------------------
        call    USTdelta        ; .   ust-on/ust+off
;--------------------------------------------------------------
        cmp     uTempReal,uTempDown
        jnc     noDown
        bsf     Kotel     ; ON  -    
noDown:
        cmp     uTempReal,uTempUp
        jc      noUP
        bcf     Kotel     ; OFF -    
noUP:
;        cmp     uTempReal,uTempUp
;        jnc     noUP
;        bsf     xxx     ; on alarm
;noUP:
;--------------------------------------------------------------
        incf    mCountBcuc,f;
        cpi     mCountBcuc,.30
        jnz     NoBlink
        clrf    mCountBcuc
        incf    mCountKeyOut,f;    
        incf    mCountBlink,f ;
        decf    mCountDown,f  ; 
NoBlink:
;--------------------------------------------------------------
        clrf    PORTB      ;   
        call    DigitOFF
        cpi     mCountIND,1
        jz      w1
        cpi     mCountIND,2
        jz      w2
        clrf    mCountIND
;--------------------------------------------------------------
        incf    mCountIND,f    ;  
        movf    mPosHigh,w     ;  
        call    hex            ; .   ASCII
        goto    DigitHigh      ;   
;--------------------------------------------------------------
w1:
        incf    mCountIND,f    ;  
        movf    mPosMidl,w     ;  
        call    hex            ; .   ASCII
        goto    DigitMidl      ;   
;--------------------------------------------------------------
w2:
        incf    mCountIND,f    ;  
        movf    mPosLow,w      ;  
        call    hex            ; .   ASCII
        goto    DigitLow       ;   
;**************************************************************
;////////////////////////////////////////////////////////////
;**************************************************************
DeltaCuc:   ;
;*************************************************************
        call    USTdelta          ; .   ust-on/ust+off
        mov     mPosHigh,wDdsHigh ;
        mov     mPosMidl,wDdsMid  ;
        mov     mPosLow,wDdsLow   ;
;-----------------------------------
;        mov     wDdsHex,uTempUp
        mov     wDdsHex,uTempDown
;        mov     wDdsHex,uTempDelta;
;-----------------------------------
        call    HexToDec          ; dds_hex -> . - 3 
        call    TimerWait
        goto    DeltaCuc
;*************************************************************
;        CALL    PIN_HI
;        CALL    initDS1821      ;   1
;**************************************************************
;////////////////////////////////////////////////////////////
;**************************************************************
DigitOFF:
        bsf     Led_Low      ;  
        bsf     Led_Midl     ;  
        bsf     Led_High     ;  
        return
;**************************************************************
DigitLow:
        bsf     Led_Midl     ;  
        bsf     Led_High     ;  
        bcf     Led_Low      ;  
        return
;**************************************************************
DigitMidl:
        bsf     Led_Low      ;  
        bsf     Led_High     ;  
        bcf     Led_Midl     ;  
        return
;**************************************************************
DigitHigh:
        bsf     Led_Low      ;  
        bsf     Led_Midl     ;  
        bcf     Led_High     ;  
        return
;**************************************************************
;////////////////////////////////////////////////////////////
;**************************************************************
PointON:    ;   
        bsf     Led_T
        return
;**************************************************************
Simbol_0:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_G
        return
;**************************************************************
Simbol_1:    ;    
        clrf    PORTB      ;   
        bsf     Led_B
        bsf     Led_C
        return
;**************************************************************
Simbol_2:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_F
        bcf     Led_C
        return
;**************************************************************
Simbol_3:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_F
        bcf     Led_E
        return
;**************************************************************
Simbol_4:    ;    
        clrf    PORTB      ;   
        bsf     Led_F
        bsf     Led_G
        bsf     Led_B
        bsf     Led_C
        return
;**************************************************************
Simbol_5:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_B
        bcf     Led_E
        return
;**************************************************************
Simbol_6:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_B
        return
;**************************************************************
Simbol_7:    ;    
        clrf    PORTB      ;   
        bsf     Led_A
        bsf     Led_B
        bsf     Led_C
        return
;**************************************************************
Simbol_8:    ;    
        mvi     PORTB,b'11111011' ;   
        return
;**************************************************************
Simbol_9:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_E
        return
;**************************************************************
Simbol_A:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_D
        return
;**************************************************************
Simbol_b:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_A
        bcf     Led_B
        return
;**************************************************************
Simbol_C:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_G
        bcf     Led_B
        bcf     Led_C
        return
;**************************************************************
Simbol_d:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_A
        bcf     Led_F
        return
;**************************************************************
Simbol_E:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_B
        bcf     Led_C
        return
;**************************************************************
Simbol_F:    ;    
        mvi     PORTB,b'11111011' ;   
        bcf     Led_B
        bcf     Led_C
        bcf     Led_D
        return
;**************************************************************
Simbol_up:    ;    
        clrf    PORTB      ;   
        bsf     Led_B
        bsf     Led_G
        bsf     Led_F
        return
;**************************************************************
Simbol_ust:    ;    
        clrf    PORTB      ;   
        bsf     Led_B
        bsf     Led_G
        bsf     Led_F
        bsf     Led_D
        bsf     Led_C
        return
;**************************************************************
Simbol_dw:    ;    
        clrf    PORTB      ;   
        bsf     Led_C
        bsf     Led_G
        bsf     Led_E
        return
;**************************************************************
Simbol_T1:    ;    
        clrf    PORTB      ;   
        bsf     Led_G
        bsf     Led_E
        bsf     Led_F
        return
;**************************************************************
Simbol_T2:    ;    
        clrf    PORTB      ;   
        bsf     Led_G
        bsf     Led_B
        bsf     Led_C
        return
;**************************************************************
Simbol_c:    ;    
        clrf    PORTB      ;   
        bsf     Led_G
        bsf     Led_A
        bsf     Led_F
        bsf     Led_B
        return
;*************************************************************
HexToDec:  ;   dds_hex -> . - 3 
;*************************************************************
        clrwdt                 ;  WDT 
        clrf    wDdsLow        ;  
        clrf    wDdsMid        ; 
        clrf    wDdsHigh       ; 
;---------------------------------------------------------
sot_cuc:                       ;  
      incf    wDdsHigh,f     ; 
        movlw   .100           ;
        subwf   wDdsHex,f      ;
        jc      sot_cuc        ;
        decf    wDdsHigh,f     ;
        movlw   .100           ;
        addwf   wDdsHex,f      ;
;---------------------------------------------------------
dec_cuc:                       ;  
        incf    wDdsMid,f      ;
        movlw   .10            ;
        subwf   wDdsHex,f      ;
        jc      dec_cuc        ;
        decf    wDdsMid,f      ;
        movlw   .10            ;
        addwf   wDdsHex,f      ;
;---------------------------------------------------------
ed_cuc:                        ;  
        incf    wDdsLow,f      ;
        movlw   .1             ;
        subwf   wDdsHex,f      ;
        jc      ed_cuc          ;
        decf    wDdsLow,f      ;
;---------------------------------------------------------
        clrwdt                 ;  WDT 
        return                 ;
;*************************************************************
USTdelta: ; .   ust-on/ust+off
;*************************************************************
        mov     uTempDelta,PORTC;
        comf    uTempDelta,f    ;
        movlw   0x07            ;
        andwf   uTempDelta,f    ;
        incf    uTempDelta,f    ;     0
;-------------------------------------------------------------
        movf   uTempDelta,w    ;
        subwf  uTempUst,w      ;   
        movwf  uTempDown       ;   
;-------------------------------------------------------------
        movf   uTempDelta,w    ;
        addwf  uTempUst,w      ;   
        movwf  uTempUp         ;   
;-------------------------------------------------------------
        return                 ;
;**************************************************************
;/////////////////////////////////////////////////////////
;**************************************************************
CheckTemp:         ;  
        CALL    startDS1821     ;    1
        CALL    readDS1821      ;   1
        MOVWF   uTempReal       ;     _
        CALL    stopDS1821      ;    1
        incf    uTempReal,f     ;
        return                  ;
;**************************************************************
;*********************************************************
;/////////////////////////////////////////////////////////
;*********************************************************
initDS1821:
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   0CH          ;  
        MOVWF   mToDS1821
        call    OutByte1wire ;   mToDS1821  DS1821
        MOVLW   03H          ;  ,   1
        MOVWF   mToDS1821
        call    OutByte1wire ;   mToDS1821  DS1821
        MOVLW   .20          ;  20    
        MOVWF   wlocal1
        CALL    DelayMs
        RETURN
;*********************************************************
startDS1821:
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   0EEH         ;  
        MOVWF   mToDS1821
        call    OutByte1wire ;   mToDS1821  DS1821
        MOVLW   .1         ; (=100)  100 
        MOVWF   wlocal1
        CALL    DelayMs
        RETURN
;*********************************************************
readDS1821:     ;  
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   0AAH         ;  
        MOVWF   mToDS1821
        CALL    OutByte1wire ;   mToDS1821  DS1821
        CALL    InByte1wire  ;    DS1821  W
        MOVF    mFromDS1821, W
        RETURN
;*********************************************************
stopDS1821:    ;  
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   22H          ;  
        MOVWF   mToDS1821
        CALL    OutByte1wire ;   mToDS1821  
        RETURN
;*********************************************************
;     1-Wire
;*********************************************************
;/////////////////////////////////////////////////////////
;*********************************************************
init1wire:  ;   DS1821
;*********************************************************
        CALL    PIN_HI  ;       -1- (R=4,7k->+5v)
        CALL    PIN_LO  ;       -0-
        MOVLW   .50     ;  500 
        CALL    DELAY_10USEC
        CALL    PIN_HI  ;       -1- (R=4,7k->+5v)
        MOVLW   .50     ;  500 
        CALL    DELAY_10USEC
        RETURN
;*********************************************************
Wait1wire:      ;  
;*********************************************************
        CALL    InByte1wire    ;    W
        MOVLW   0FFH           ;
        SUBWF   mFromDS1821, W ;
        BTFSS   STATUS, ZR     ;
        GOTO    Wait1wire      ;
        RETURN
;*********************************************************
InByte1wire:    ;    W
;*********************************************************
        MOVLW   .8
        MOVWF   mDelay
        CLRF    mFromDS1821
IN_BYTE_1:
        CALL    PIN_LO  ;       -0-
        NOP
        NOP
        NOP
        NOP
        CALL    PIN_HI ;       -1- (R=4,7k->+5v)
        nop16mhz   ;  28  
        MOVF    PORTC, W        ; 7 usecs later, fetch from NogaDS1821
        MOVWF   wTEMP
        BTFSS   wTEMP, NogDS1821
        BCF     STATUS,CR       ; its a zero
        BTFSC   wTEMP, NogDS1821
        BSF     STATUS, CR       ; its a one
        RRF     mFromDS1821, F
        MOVLW   .6              ; now delay 60 usecs
        CALL    DELAY_10USEC
        DECFSZ  mDelay, F
        GOTO    IN_BYTE_1
        MOVFW   mFromDS1821          ; return the result in W
        RETURN
;*********************************************************
OutByte1wire: ;   mToDS1821  
;*********************************************************
        MOVLW   .8          ; 8  - 
        MOVWF   mDelay
OUT_BYTE_1:
        RRF     mToDS1821, F
        BTFSS   STATUS, CR
        GOTO    OUT_0
        GOTO    OUT_1
OUT_BYTE_2:
        DECFSZ  mDelay, F
        GOTO    OUT_BYTE_1
        RETURN
;-------------------------------------------
OUT_0:
        CALL    PIN_LO  ;       -0-
        MOVLW   .6      ; for 60 usecs
        CALL    DELAY_10USEC
        CALL    PIN_HI ;       -1- (R=4,7k->+5v)
        GOTO    OUT_BYTE_2
OUT_1:
        CALL    PIN_LO ;       -0-
        CALL    PIN_HI ;       -1- (R=4,7k->+5v)
        MOVLW   .6
        CALL    DELAY_10USEC
        GOTO    OUT_BYTE_2
;*********************************************************
PIN_HI:  ;   
;*********************************************************
        BSF     STATUS, RP0
        BSF     TRISC, NogDS1821 ; high impedance
        BCF     STATUS, RP0
        RETURN
;*********************************************************
PIN_LO: ;       -0-
;*********************************************************
        BCF     PORTC, NogDS1821
        BSF     STATUS, RP0
        BCF     TRISC, NogDS1821    ; low impedance zero
        BCF     STATUS, RP0
        RETURN
;*********************************************************
DelayMs:
;*********************************************************
OUTTER:
        MOVLW   .110      ;  1 
        MOVWF   wlocal2
INNER:
        nop16mhz   ;  28  
        DECFSZ  wlocal2, F
        GOTO    INNER
        DECFSZ  wlocal1, F
        GOTO    OUTTER
        RETURN
;*********************************************************
DELAY_10USEC:  ;    W * 10 
;*********************************************************
        MOVWF   wlocal1
DELAY_10USEC_1:
        nop16mhz   ;  28  
        DECFSZ  wlocal1, F
        GOTO    DELAY_10USEC_1
        RETURN
;**************************************************************
;/////////////////////////////////////////////////////////
;**************************************************************
  End  ;    BrSoft Copyright (C) 2005 Bogdanov Andrew
;**************************************************************






